#ifndef GLBOX_H
#define GLBOX_H

#define _CTYPE_H_
#define _GLIBCXX_CCTYPE 1
#include <memory>
#include <vector>

#include "gldrawable.h"
#include "textureatlas.h"

class GLBox : public GLDrawable
{
public:
    GLBox(float width, float height, float length, float cenX, float cenY, float cenZ, TextureAtlasEntry fr, TextureAtlasEntry ba, TextureAtlasEntry to, TextureAtlasEntry bot, TextureAtlasEntry le, TextureAtlasEntry ri, bool draw_front, bool draw_back, bool draw_top, bool draw_bottom, bool draw_left, bool draw_right);
    GLBox(float width, float height, float length, float cenX, float cenY, float cenZ, TextureAtlasEntry fr, TextureAtlasEntry ba, TextureAtlasEntry to, TextureAtlasEntry bot, TextureAtlasEntry le, TextureAtlasEntry ri)
        : GLBox(width, height, length, cenX, cenY, cenZ, fr, ba, to, bot, le, ri, true, true, true, true, true, true) {}

    void addChild(std::shared_ptr<GLDrawable> child) { childs.push_back(child); }
    void draw();

private:
    float cenX, cenY, cenZ; //Center of rotation

    std::vector<VERTEX> vertices;
    std::vector<std::shared_ptr<GLDrawable> > childs;
};

#endif // GLBOX_H
