#ifndef WORLD_H
#define WORLD_H

#include <vector>

#include "block_data.h"

class Chunk;

class World
{
public:
    World();
    ~World();
    BLOCK getBlock(int x, int y, int z);
    void setPosition(int x, int y, int z);
    void render();

private:
    Chunk *findChunk(int x, int y, int z);
    Chunk *generateChunk(int x, int y, int z);

    static constexpr int field_of_view = 1;
    int cen_x = -1, cen_z = -1;

    std::vector<Chunk*> map;
    std::vector<Chunk*> visible_chunks;
};

#endif // WORLD_H
